Subject: [core] Adam Roach's No Objection on draft-ietf-core-hop-limit-06: (with COMMENT)

From: Adam Roach via Datatracker <[email-masked]>
Date: Tue, 15 Oct 2019 21:02:45 -0700

Adam Roach has entered the following ballot position for
draft-ietf-core-hop-limit-06: No Objection

When responding, please keep the subject line intact and reply to all
email addresses included in the To and CC lines. (Feel free to cut this
introductory paragraph, however.)

Please refer to https://www.ietf.org/iesg/statement/discuss-criteria.html
for more information about IESG DISCUSS and COMMENT positions.

The document, along with other ballot positions, can be found here:
https://datatracker.ietf.org/doc/draft-ietf-core-hop-limit/

----------------------------------------------------------------------
COMMENT:
----------------------------------------------------------------------

Thanks to everyone who worked on this document.

I'm a little surprised that the treatment of loops that go between HTTP and
CoAP networks involves a simple observation that detection of such cases simply
won't work, without any attempt at mitigation.

I'm sympathetic to the observation during WGLC that directly interworking with
RFC 8586 isn't feasible, but surprised that more primitive approaches to at
least preserving the CoAP Hop-Count as it crossed the HTTP network weren't
considered. There are aesthetic discussions to be had around, e.g., defining an
HTTP "Hop-Count" header field (which isn't acted on by the HTTP network, but
serves the purpose of preserving the value during transit) or overloading the
semantics (but not really the meaning) of the HTTP "Max-Forwards" header field,
or (in extremis) squirreling the Hop-Count away in the `pseudonym` portion of
the inserted HTTP Via header field.  But I think the high order bit here is
that preserving the Hop-Count value through the HTTP network would be trivial,
and would prevent the identified shortcoming of the current mechanism.

---

From: <[email-masked]>
Date: Thu, 17 Oct 2019 07:28:47 +0000

Hi Adam, 

It was raised in the WG whether we want to fix this or only record the issue. I'm not convinced it is worth to request a new HTTP header to address a specific case, e.g., two COAP realms connected via an HTTP leg. For such loop to happen, this means that CoAP nodes are able to communicate natively using CoAP without crossing the proxies. The natural question is why then these proxies are deployed. 

I do think that the current approach in the draft is the right one: record a potential issue without speculating on how the issue is critical given that we don't have arguments.

Please note also that Section 10 of RFC7252 only discusses CoAP-to-HTTP proxy and vice-versa, and does not discuss CoAP-to-HTTP-to-CoAP schemes. May be an item to clarify in 7252-bis.

Thank you. 

Cheers,
Med

> -----Message d'origine-----
> De : Adam Roach via Datatracker [mailto:[email-masked]]
> Envoyé : mercredi 16 octobre 2019 06:03
> À : The IESG
> Cc : [email-masked]; Jaime Jimenez; core-
> [email-masked]; [email-masked]; [email-masked]
> Objet : Adam Roach's No Objection on draft-ietf-core-hop-limit-06: (with
> COMMENT)
>

---

From: Carsten Bormann <[email-masked]>
Date: Thu, 17 Oct 2019 12:10:27 +0200

(Background:)

I seem to remember that for a short time during the development of OSCORE we thought about defining an HTTP header field “CoAP-Option” (not sure that was the actual name) that can be used for tunneling any kind of CoAP Options through HTTP segments of a proxy path.
I forget why we eventually decided we didn’t need this, but the idea of course can be revived; CoAP’s option types are stylized enough that this can be made to work in general.
I wouldn’t necessarily put this into this draft; an update of RFC 8075 might be a good receptacle.

Grüße, Carsten

> On Oct 17, 2019, at 09:28, <[email-masked]> <[email-masked]> wrote:
> 
> Hi Adam, 
>

---

From: Thomas Fossati <[email-masked]>
Date: Thu, 17 Oct 2019 10:53:07 +0000

Hi Carsten,

[ trimming CC ]

On 17/10/2019, 11:10, "core on behalf of Carsten Bormann" <[email-masked] on behalf of [email-masked]> wrote:
> CoAP’s option types are stylized enough that this can be made to work
> in general.

True, the mapping in both direction should be pretty straightforward.

> might be a good receptacle.

Scope-wise:
- 7252 deals with C -> C2H -> H
- 8075 deals with H -> H2C -> C

Options-to-Headers transcoding pops up when you try composing the two:
C -> C2H -> H -> H2C -> C.

So, its scope seems larger than 7252 or 8075 alone.

It looks like if we really want to do this, we might need a separate
doc updating both.

Cheers

IMPORTANT NOTICE: The contents of this email and any attachments are confidential and may also be privileged. If you are not the intended recipient, please notify the sender immediately and do not disclose the contents to any other person, use it for any purpose, or store or copy the information in any medium. Thank you.